<?php

namespace Pinpoint\CarouselManager\Controller\Adminhtml\Carousel;

use Magento\Backend\App\Action;
use Magento\Framework\Controller\Result\JsonFactory;
use Pinpoint\CarouselManager\Model\SlideRepository;
use Psr\Log\LoggerInterface;

class ImageDelete extends Action
{

    /**
     * Authorization level of a basic admin session
     *
     * @see _isAllowed()
     */
    const ADMIN_RESOURCE = 'Pinpoint_CarouselManager::carousel';

    /**
     * @var JsonFactory
     */
    protected $resultJsonFactory;

    /**
     * @var LoggerInterface
     */
    protected $logger;

    /**
     * @var \Magento\Framework\Filesystem\Driver\File
     */
    protected $file;

    /**
     * Itemdelete constructor.
     * @param Action\Context $context
     * @param JsonFactory $resultJsonFactory
     * @param SlideRepository $slideRespository
     */
    public function __construct(
        Action\Context $context,
        JsonFactory $resultJsonFactory,
        LoggerInterface $logger,
        \Magento\Framework\Filesystem\Driver\File $file
    ) {
        parent::__construct($context);
        $this->resultJsonFactory = $resultJsonFactory;
        $this->logger = $logger;
        $this->file = $file;
    }

    /**
     * @return mixed
     */
    public function execute()
    {
        $success = false;
        $resultPage = $this->resultJsonFactory->create();
        $path = $this->getRequest()->getParam('path');
        if ($path) {
            try {
                $success = true;
                $this->file->deleteFile($path);
            } catch (\Exception $e) {
                $this->logger->error($e->getMessage());
            }
        }
        return $resultPage->setData(['success' => $success]);
    }
}
